Skip to content

# Hash

The tool to check the availability or syntax of domain, IP or URL.

::

    ██████╗ ██╗   ██╗███████╗██╗   ██╗███╗   ██╗ ██████╗███████╗██████╗ ██╗     ███████╗
    ██╔══██╗╚██╗ ██╔╝██╔════╝██║   ██║████╗  ██║██╔════╝██╔════╝██╔══██╗██║     ██╔════╝
    ██████╔╝ ╚████╔╝ █████╗  ██║   ██║██╔██╗ ██║██║     █████╗  ██████╔╝██║     █████╗
    ██╔═══╝   ╚██╔╝  ██╔══╝  ██║   ██║██║╚██╗██║██║     ██╔══╝  ██╔══██╗██║     ██╔══╝
    ██║        ██║   ██║     ╚██████╔╝██║ ╚████║╚██████╗███████╗██████╔╝███████╗███████╗
    ╚═╝        ╚═╝   ╚═╝      ╚═════╝ ╚═╝  ╚═══╝ ╚═════╝╚══════╝╚═════╝ ╚══════╝╚══════╝

Provides the hashing helpers.

Author: Nissar Chababy, @funilrys, contactTATAfunilrysTODTODcom

Special thanks: https://pyfunceble.github.io/#/special-thanks

Contributors: https://pyfunceble.github.io/#/contributors

Project link: https://github.com/funilrys/PyFunceble

Project documentation: https://docs.pyfunceble.com

Project homepage: https://pyfunceble.github.io/

License: ::

    Copyright 2017, 2018, 2019, 2020, 2022, 2023, 2024 Nissar Chababy

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        https://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

## `HashHelper`

Simplify the hashing of data or file content.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`algo` | `str` | The algorithm to use for hashing. | `None`

Raises:

Type | Description
--- | ---
`ValueError` | When the given algo is not known.

Source code in `PyFunceble/helpers/hash.py`

     59
     60
     61
     62
     63
     64
     65
     66
     67
     68
     69
     70
     71
     72
     73
     74
     75
     76
     77
     78
     79
     80
     81
     82
     83
     84
     85
     86
     87
     88
     89
     90
     91
     92
     93
     94
     95
     96
     97
     98
     99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161

    class HashHelper:
        """
        Simplify the hashing of data or file content.

        :param str algo:
            The algorithm to use for hashing.

        :raise ValueError: When the given algo is not known.
        """

        _algo: str = "SHA512_224"

        def __init__(self, algo: Optional[str] = None):
            if algo is not None:
                self.algo = algo

        @property
        def algo(self) -> str:
            """
            Provides the current state fo the :code:`_algo` attribute.
            """

            return self._algo

        @algo.setter
        def algo(self, value: str) -> None:
            """
            Sets the algorithm to work with.

            :param value:
                The name of the hash to use.

            :raise TypeError:
                When :code:`value` is not a :py:class:`str`.
            """

            if not isinstance(value, str):
                raise TypeError(f"<value> should be {str}, {type(value)} given.")

            value = value.lower()

            if value not in hashlib.algorithms_available:
                raise ValueError(
                    f"<value> ({value!r}) in an unknown algorithm "
                    f"({hashlib.algorithms_available})."
                )

            self._algo = value

        def set_algo(self, value: str) -> "HashHelper":
            """
            Sets the algorithm to work with.

            :param value:
                The name of the hash to use.
            """

            self.algo = value

            return self

        def hash_file(self, file_path: str) -> str:
            """
            Hashes the content of the given file.

            :param file_path:
                The path of the file to read.
            """

            block_size = 4096

            digest = hashlib.new(self.algo)

            with FileHelper(file_path).open("rb") as file_stream:
                block = file_stream.read(block_size)

                while block:
                    digest.update(block)
                    block = file_stream.read(block_size)

            return digest.hexdigest()

        def hash_data(self, data: Union[str, bytes]) -> str:
            """
            Hashes the given data.

            :param data:
                The data to hash.

            :raise TypeError:
                When :code:`data` is not :py:class:`str` or :py:class:`bytes`.
            """

            if not isinstance(data, (bytes, str)):
                raise TypeError(f"<data> should be {bytes} or {str}, {type(data)}, given.")

            if isinstance(data, str):
                data = data.encode()

            digest = hashlib.new(self.algo)
            digest.update(data)

            return digest.hexdigest()

### `algo: str` `property` `writable`

Provides the current state fo the :code:`_algo` attribute.

### `hash_data(data)`

Hashes the given data.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`data` | `Union[str, bytes]` | The data to hash. | required

Raises:

Type | Description
--- | ---
`TypeError` | When :code:`data` is not class:`str` or class:`bytes`.

Source code in `PyFunceble/helpers/hash.py`

    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161

    def hash_data(self, data: Union[str, bytes]) -> str:
        """
        Hashes the given data.

        :param data:
            The data to hash.

        :raise TypeError:
            When :code:`data` is not :py:class:`str` or :py:class:`bytes`.
        """

        if not isinstance(data, (bytes, str)):
            raise TypeError(f"<data> should be {bytes} or {str}, {type(data)}, given.")

        if isinstance(data, str):
            data = data.encode()

        digest = hashlib.new(self.algo)
        digest.update(data)

        return digest.hexdigest()

### `hash_file(file_path)`

Hashes the content of the given file.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`file_path` | `str` | The path of the file to read. | required

Source code in `PyFunceble/helpers/hash.py`

    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139

    def hash_file(self, file_path: str) -> str:
        """
        Hashes the content of the given file.

        :param file_path:
            The path of the file to read.
        """

        block_size = 4096

        digest = hashlib.new(self.algo)

        with FileHelper(file_path).open("rb") as file_stream:
            block = file_stream.read(block_size)

            while block:
                digest.update(block)
                block = file_stream.read(block_size)

        return digest.hexdigest()

### `set_algo(value)`

Sets the algorithm to work with.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `str` | The name of the hash to use. | required

Source code in `PyFunceble/helpers/hash.py`

    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118

    def set_algo(self, value: str) -> "HashHelper":
        """
        Sets the algorithm to work with.

        :param value:
            The name of the hash to use.
        """

        self.algo = value

        return self